import 'package:libaqueous/src/api/room.dart';
import 'package:libaqueous/src/api/store.dart';
import 'package:libaqueous/src/api/user.dart';
import 'package:libaqueous/src/rest/api.dart';
import 'package:rxdart/rxdart.dart';

abstract class ClientChanges {
  static const NoChange = 0x0;
  static const RoomsChange = 0x1;
  static const UsersChange = 0x2;
}

abstract class ClientEmitter {
  Observable<List<Room>> get roomsObservable;
}

abstract class Client implements ClientEmitter {
  MatrixAPI get api;

  String get homeServer;

  String get userID;

  String get token;

  String get transactionID;

  User get myUser;

  Store get store;

  bool get isRunning;

  Map<String, User> get users;

  Map<String, Room> get rooms;

  Future<void> loadFromStore();

  Future<void> startSync();

  void stopSync();

  Future<void> logout();

  Future<Room> getRoom(String id);

  Future<User> getUser(String id);
}
