import 'package:libaqueous/src/api/client.dart';
import 'package:libaqueous/src/api/data/data_holder.dart';
import 'package:libaqueous/src/api/user.dart';

class DefaultUserData {
  String id;
  String name;
  Uri avatarUrl;
}

class DefaultUser implements User, DataHolder<DefaultUserData> {
  DefaultUser(this._client, {String id}) : _d = DefaultUserData()..id = id {}

  DefaultUser.fromData(this._client, this._d) {}

  final Client _client;

  final DefaultUserData _d;

  DefaultUserData get d => _d;

  Client get client => _client;

  String get id => d.id;

  Uri get avatarUrl => d.avatarUrl;

  String get displayName => d.name ?? d.id;

  String get name => d.name;
}
